
/***********************************************/
/****               StripCR V2.1            ****/
/****  (c) 1998 - 2000 Alessandro Pedretti  ****/
/****    Strips the CR from PC text files   ****/
/***********************************************/


#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <errno.h>

/**** Definitions ****/

#define  SCR_VER        "2.1"
#define  SCR_DATE       "20.04.2000"
#define  SCR_COPYRIGHT  "1998-2000"

#define  FALSE          0
#define  TRUE           1

#ifdef AMIGA
static char	*StripCR_Ver = "StripCR " SCR_VER " (" SCR_DATE ")";
#endif

#if defined(WIN32) || defined(_WIN32) || defined(_WIN32_)
#include <malloc.h>
#include <errno.h>
#else
#include <stdlib.h>
#endif

typedef short BOOL;


/**** Prototypes ****/

BOOL Errore(const char *, ...);
BOOL PrintDosErr(void);


/**** Main code ****/

int main(int argc, char *argv[])
{
  char			*Buf;
  FILE			*FH;
  register char		*Ptr;
  register unsigned int	Stripped;
  short			Chk;
  unsigned int		Len;

  if (argc > 1) {
    while(--argc) {
      if ((FH = (FILE *)fopen(*++argv, "rb")) != NULL) {
        printf("Processing \"%s\"\n", *argv);

        /**** Calculate the length of file ****/

        fseek(FH, 0, SEEK_END);
        Len = ftell(FH);
        fseek(FH, 0, SEEK_SET);

        if ((Buf = (char *)malloc(Len)) != NULL) {
          if (fread(Buf, Len, 1, FH) == 1) {

            /**** Strip only if needed ****/

            if (strchr(Buf, 13)) {
              fclose(FH);
              if ((FH = (FILE *)fopen(*argv, "wb")) != NULL) {
                Chk      = TRUE;
                Ptr      = Buf;
                Stripped = 0;
		/*
                --Len;
		*/
                while((Chk) && (Len--)) {
                  if (*Ptr != 13) {
                    if (putc(*Ptr, FH) != *Ptr) Chk = PrintDosErr();
                  } else ++Stripped;

                  /**** Add a LF if needed (for IRIX source compatibility) ****/

                  if ((!Len) && (*Ptr != 10) && (putc(10, FH) != 10))
                    Chk = PrintDosErr();
                  ++Ptr;
                }
                if ((Chk) && (Stripped))
                  printf(" %d CR stripped\n", Stripped);
              } else PrintDosErr();
            }
          } else PrintDosErr();
          free(Buf);
        } else Errore("Out of memory");
        fclose(FH);
      } else Errore("Can't open \"%s\"", *argv);
    }
  } else fprintf(stderr, "\nStripCR V" SCR_VER " - (c) " SCR_COPYRIGHT \
                         " Alessandro Pedretti\n" \
                         "Usage: stripcr FILE ...\n\n");

  return 0;
}


/**** Shows an error ****/

BOOL Errore(const char *Err, ...)
{
  char          Buf[128];
  va_list       vl;

  strcpy(Buf, " ERROR: ");
  va_start(vl, Err);
  strcat(Buf, Err);
  strcat(Buf, ".\n\n");
  vfprintf(stderr, Buf, vl);
  va_end(vl);

  return FALSE;
}


/**** Show a system error ****/

BOOL PrintDosErr(void)
{
  fprintf(stderr, " DOS ERROR: %s", strerror(errno));

  return FALSE;
}
