/*

             **************************************************
             ****             VEGA - Bzip2 V1.0            ****
             ****            Interface to libbz2           ****
             **** Copyright 1996-2000, Alessandro Pedretti ****
             **************************************************



*/

#include <stdio.h>
#include <string.h>

#include "globstr.h"
#include "Bzip2/bzlib.h"

#define  FALSE                  0
#define  TRUE                   1
#define  BZ2_BUFFER_SIZE        65536


/**** Local prototypes ****/

/* Some VEGA definitions are incompatible with the standard windows.h */
/* file and thus can't be used in the following prototypes            */

void         *Alloca(unsigned int);
short        CatErr(unsigned int, ...);
short        BZ2_DepackFile(char *, char *);
static short BZ2_Error(BZFILE *FH);
short        PrintDosErr(void);


/**** Decompress a file into another ****/

short BZ2_DepackFile(char *Src, char *Dest)
{
  BZFILE        *FI;
  char          *Buf;
  FILE          *FO;
  int           Rd;

  short        Ret = TRUE;

  if (Buf = (char *)Alloca(BZ2_BUFFER_SIZE)) {
    if (FI = BZ2_bzopen(Src, "rb")) {
      if (FO = fopen(Dest, "wb")) {
        while((Ret) && (Rd = BZ2_bzread(FI, Buf, BZ2_BUFFER_SIZE))) {
          if (Rd == -1)
            Ret = BZ2_Error(FI);
          else if (fwrite(Buf, Rd, 1, FO) != 1)
           Ret = PrintDosErr();
        }
        fclose(FO);
      } else Ret = PrintDosErr();
      BZ2_bzclose(FI);
    } else Ret = FALSE;
  } else Ret = FALSE;

  return Ret;
}


/**** Show a bzip2 error ****/

static short BZ2_Error(BZFILE *FH)
{
  int           err;

  return CatErr(MSG_ERR_BZIP2_ERROR, BZ2_bzerror(FH, &err));
}
