/*

             **************************************************
             ****             VEGA - XYZ V1.1              ****
             ****              Loader & saver              ****
             **** Copyright 1996-2000, Alessandro Pedretti ****
             **************************************************




*/

#include <ctype.h>
#include <stdio.h>
#include <string.h>

#include "globdef.h"
#include "globvar.h"


/**** XYZ Loader ****/

ATOMO *XyzLoad(FILE *FH, RECORD *Lin, ULONG *TotAtomi)
{
  ATOMO		       *InizAtm;
  register ATOMO       *Atm;

  do {
    if (*Lin -> Line != '\n') {
      if (Atm = AllocAtm(&InizAtm, TotAtomi)) {
        sscanf(Lin -> Line, "%2s %f %f %f",
               Atm -> Name.C, &Atm -> x, &Atm -> y, &Atm -> z);
        Atm -> Elem.C[0] = (char)toupper(Atm -> Name.C[0]);
        if (Atm -> Name.C[1]) Atm -> Elem.C[1] = (char)tolower(Atm -> Name.C[1]);
      } else break;
    }
  } while(fgets(Lin -> Line, LINELEN, FH));
  if (Atm) {
    Atm -> Flags = 2;
    LastAtm      = Atm;
  }

  return InizAtm;
}


/**** XYZ Saver ****/

BOOL XyzSave(FILE *FH, register ATOMO *Atm)
{
  BOOL		Ret = TRUE;

  while((Ret) && (Atm)) {
    if (fprintf(FH, "  %-2.2s %13.5f  %13.5f  %13.5f\n",
                Atm -> Elem.C, Atm -> x, Atm -> y, Atm -> z) < 0)
      Ret = PrintDosErr();
    Atm = Atm -> Ptr;
  } /* End of atom loop */

  return Ret;
}
